(function() {
	tinymce.PluginManager.add('ebay_search', function( editor, url ) {
		var sh_tag = 'ebay_search';
		var stubId = "ebay_search";

		//helper functions 
		function getAttr(s, n) {
			r = new RegExp(n + '=\"([^\"]*)\"', 'g').exec(s);
			if (!r) r = new RegExp(n + '=(.+?)([\\s$])', 'g').exec(s);
			return r ?  window.decodeURIComponent(r[1]) : '';
		};

		function jsonEnc(str) {
			var out = JSON.stringify(str);
			return out.replace(/^"(.+(?="$))"$/, '$1');
		}

		function html( dat ,con) {
			var placeholder = url + '/images/ebaysearchpanel.jpg';
			data = window.encodeURIComponent( dat );
			content = window.encodeURIComponent( con );

			var html = '<img src="' + placeholder + '" class="mceItem wp-' + sh_tag + '" ' + 'data-sh-attr="' + data + '" data-sh-content="'+ con+'" data-mce-resize="false" data-mce-placeholder="1" />';
			/*
			var preview = "";
			jQuery.ajax({
				type : "post",
				async: false,
				url : fu_ebay_adminurl,
				data : {
					action : "fu_ebay_load_search",
					fu_ebay_title : jsonEnc(con),
					fu_ebay_query : jsonEnc(getAttr(dat,'query')),
					fu_ebay_sort : getAttr(dat,'sort'),
					fu_ebay_categoryIds : jsonEnc(getAttr(dat,'category')),
					fu_ebay_sellers : jsonEnc(getAttr(dat,'seller')),
					fu_ebay_minPrice : getAttr(dat,'minprice'),
					fu_ebay_maxPrice : getAttr(dat,'maxprice'),
					fu_ebay_picwidth : getAttr(dat,'picwidth'),
					fu_ebay_cols : getAttr(dat,'columns'),
					fu_ebay_rows : getAttr(dat,'rows'),
					fu_ebay_slideshow : getAttr(dat,'slideshow'),
					fu_ebay_slides : getAttr(dat,'slides'),
					fu_ebay_slideId : 1,
					fu_ebay_customId : getAttr(dat,'customid'),
					nonce : fu_ebay_adminsearchnonce,
				},
				success : function( response ) {
					preview = '<span id="preview">' + response + '</span>';
				},
				error: function(e) {
					preview = "Fast eBay Listings deferred loading error: " + e;
					console.log("Fast eBay Listings deferred loading error: " + e);
				}
			});

			html += preview;
      */
			return html;
		}

		function replaceShortcodes( content ) {
			return content.replace( /\[(fu_ebay_search|ebay_search)([^\]]*)\]([^\]]*)\[\/(fu_ebay_search|ebay_search)\]/g, function( all,tag,attr,con) {
				return html(attr , con);
			});
		}

		function restoreShortcodes( content ) {
			return content.replace( /(?:<p(?: [^>]+)?>)*(<img [^>]+>)(?:<\/p>)*/g, function( match, image ) {
			//return content.replace( /(?:<p(?: [^>]+)?>.*?)*(<img [^>]+>)(?:.*<\/p>)*(<div class="fu_ebay_results_container".*<\/div>)*/g, function( match, image ) {
				if (!getAttr( image, 'class' ).includes('wp-' + sh_tag)) return match;
				var data = getAttr( image, 'data-sh-attr' );
				var con = getAttr( image, 'data-sh-content' );

				if ( data ) {
					return '<p>[' + sh_tag + data + ']' + con + '[/'+sh_tag+']</p>';
				}
				return match;
			});
		}

		//add popup
		editor.addCommand('ebay_search_popup', function(ui, v) {
			//setup defaults
			var content = v.content ? v.content : '';
			var query = v.query ? v.query : '';
			var category = v.category ? v.category : '';
			var seller = v.seller ? v.seller : '';
			var minprice = v.minprice ? v.minprice : '';
			var maxprice = v.maxprice ? v.maxprice : '';
			var sort = v.sort ? v.sort : '';
			var rows = v.rows ? v.rows : '';
			var columns = v.columns ? v.columns : '';
			var slideshow = v.slideshow ? v.slideshow : '';
			var slides = v.slides ? v.slides : '';
			var picwidth = v.picwidth ? v.picwidth : '';
			var customid = v.customid ? v.customid : '';
			
			editor.windowManager.open( {
				title: 'Fast eBay Listings Search',
				body: [
					{
						type: 'textbox',
						name: 'content',
						label: 'Results Title',
						value: content
					},				       
					{
						type: 'textbox',
						name: 'query',
						label: 'Query',
						value: query,
						tooltip: 'Enter eBay search query keywords',
						minWidth: 300,
					},
					{
						type: 'textbox',
						name: 'category',
						label: 'Category',
						value: category,
						tooltip: 'Leave blank for any. Add up to 3 (comma separated)'
					},
					{
						type: 'textbox',
						name: 'seller',
						label: 'Seller',
						value: seller,
						tooltip: 'Leave blank for default; \'all\' for all; \'author\' for post author'
					},	
					{
						type: 'listbox',
						name: 'sort',
						label: 'Sorting',
						value: sort,
						'values': [						           
							{text: 'Best Match', value: 'BestMatch'},
							{text: 'Highest Price First', value: 'CurrentPriceHighest'},
							{text: 'Nearest First', value: 'DistanceNearest'},
							{text: 'Ending Soonest', value: 'EndTimeSoonest'},
							{text: 'Highest Price + P&P First', value: 'PricePlusShippingHighest'},
							{text: 'Lowest Price + P&P First', value: 'PricePlusShippingLowest'},
							{text: 'Newest First', value: 'StartTimeNewest'}
						],
						tooltip: 'Select what sort order results should be presented in'
					},
					{
						type: 'textbox',
						subtype: 'number',
						name: 'picwidth',
						label: 'Picture Width',
						value: picwidth,
						tooltip: 'Leave blank for default from settings',
						maxWidth: 100,
						maxLength: 4,
					},	
					{
						layout: 'grid',
						name: 'align',
						label: 'Min / Max Price',
						type: 'form',
						columns: '2',
						spacingH: 10,
						spacingV: 0,
						items: [
							{
								type: 'textbox',
								subtype: 'number',
								name: 'minprice',
								value: minprice,
								tooltip: 'Leave blank for no filter (don\'t add currently)',
								maxWidth: 100,
								maxLength: 10,
							},						
							{
								type: 'textbox',
								subtype: 'number',
								name: 'maxprice',
								value: maxprice,
								tooltip: 'Leave blank for no filter (don\'t add currently)',
								maxWidth: 100,
								maxLength: 10,
							},	
						]
					},												
					{
						layout: 'grid',
						name: 'align',
						label: 'Results Columns / Rows',
						type: 'form',
						columns: '2',
						spacingH: 10,
						spacingV: 0,
						items: [
							{
								type: 'textbox',
								subtype: 'number',
								name: 'columns',
								value: columns,
								tooltip: 'Leave blank to use default from settings',
								maxWidth: 100,
								maxLength: 2,
							},	
							{
								type: 'textbox',
								subtype: 'number',
								name: 'rows',
								value: rows,
								tooltip: 'Leave blank to use default from settings',
								maxWidth: 100,
								maxLength: 2,
							},	
						]
					},							
					{
						layout: 'grid',
						name: 'align',
						label: 'Slideshow Style / Num Slides',
						type: 'form',
						columns: '2',
						spacingH: 10,
						spacingV: 0,
						items: [
							{
								type: 'listbox',
								name: 'slideshow',
								value: slideshow,
								'values': [						           
											{text: 'Settings Default', value: ''},
											{text: 'None', value: 'None'},
											{text: 'Manual', value: 'Manual'},
											{text: 'Auto', value: 'Auto'},
										],
							},						
							{
								type: 'textbox',
								subtype: 'number',
								name: 'slides',
								value: slides,
								tooltip: 'Leave blank to use default from settings',
								maxWidth: 50,
								maxLength: 2,
							},	
						]
					},							
					{
						type: 'textbox',
						name: 'customid',
						label: 'Custom Id',
						value: customid,
						tooltip: 'Used for tracking and reporting',
						maxWidth: 300,
					},	
				],
				onsubmit: function( e ) {
					var shortcode_str = '[' + sh_tag;
					// check for query
					if (typeof e.data.query != 'undefined' && e.data.query.length)
						shortcode_str += ' query="' + e.data.query + '"';
					// check for category
					if (typeof e.data.category != 'undefined' && e.data.category.length)
						shortcode_str += ' category="' + e.data.category + '"';
					// check for seller
					if (typeof e.data.seller != 'undefined' && e.data.seller.length)
						shortcode_str += ' seller="' + e.data.seller + '"';
					// check for min/max price
					if (typeof e.data.minprice != 'undefined' && e.data.minprice.length)
						shortcode_str += ' minprice="' + e.data.minprice + '"';
					if (typeof e.data.maxprice != 'undefined' && e.data.maxprice.length)
						shortcode_str += ' maxprice="' + e.data.maxprice + '"';
					// add sort
					shortcode_str += ' sort="'+e.data.sort+'"';
					// check for rows/columns
					if (typeof e.data.rows != 'undefined' && e.data.rows.length)
						shortcode_str += ' rows="' + e.data.rows + '"';
					if (typeof e.data.columns != 'undefined' && e.data.columns.length)
						shortcode_str += ' columns="' + e.data.columns + '"';
					// check for slides
					shortcode_str += ' slideshow="'+e.data.slideshow+'"';
					if (typeof e.data.slides != 'undefined' && e.data.slides.length)
						shortcode_str += ' slides="' + e.data.slides + '"';
					// check for picwidth
					if (typeof e.data.picwidth != 'undefined' && e.data.picwidth.length)
						shortcode_str += ' picwidth="' + e.data.picwidth + '"';
					// check for customid
					if (typeof e.data.customid != 'undefined' && e.data.customid.length)
						shortcode_str += ' customid="' + e.data.customid + '"';

					//add panel content
					shortcode_str += ']' + e.data.content + '[/' + sh_tag + ']';
					//insert shortcode to tinymce
					editor.insertContent( shortcode_str);
				}
			});
		});

		//replace from shortcode to an image placeholder
		editor.on('BeforeSetcontent', function(event){ 
			event.content = replaceShortcodes( event.content );
		});

		//replace from image placeholder to shortcode
		editor.on('GetContent', function(event){
			event.content = restoreShortcodes(event.content);
		});

		//open popup on placeholder double click
		editor.on('DblClick',function(e) {
			var cls  = e.target.className.indexOf('wp-' + sh_tag);
			if ( e.target.nodeName == 'IMG' && e.target.className.indexOf('wp-' + sh_tag) > -1 ) {
				var data = e.target.attributes['data-sh-attr'].value;
				var content = e.target.attributes['data-sh-content'].value;
				data = window.decodeURIComponent(data);
				content = window.decodeURIComponent(content);

				editor.execCommand('ebay_search_popup','',{
					query : getAttr(data,'query'),
					category : getAttr(data,'category'),
					seller : getAttr(data,'seller'),
					minprice : getAttr(data,'minprice'),
					maxprice : getAttr(data,'maxprice'),
					sort   : getAttr(data,'sort'),
					rows   : getAttr(data,'rows'),
					columns   : getAttr(data,'columns'),
					slideshow   : getAttr(data,'slideshow'),
					slides   : getAttr(data,'slides'),
					picwidth : getAttr(data,'picwidth'),
					customid : getAttr(data,'customid'),
					content: content
				});
			}
		});
	});
})();