<?php

require_once __DIR__."/apicall_browse_search.php";

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Basic ebay search widget
class fuEbayWidgetSearch extends WP_Widget 
{
  protected $queryLabel = 'Search query:';

	// constructor
	function __construct($name = '') 
	{
    if (empty($name)) $name = __('Fast eBay Listings Fixed Search', 'fastebaylistings');
    parent::__construct(false, $name);
	}

	// widget form creation
	function form($instance) 
	{	
    global $ebay_sort_order;
    global $fu_ebay_slideshow_styles;
  
    $title = ! empty( $instance['title'] ) ? $instance['title'] : '';
    $content = ! empty( $instance['content'] ) ? $instance['content'] : '';
    $query = ! empty( $instance['query'] ) ? $instance['query'] : '';
    $category = ! empty( $instance['category'] ) ? $instance['category'] : '';
    $seller = ! empty( $instance['seller'] ) ? $instance['seller'] : '';
    $columns = ! empty( $instance['columns'] ) ? $instance['columns'] : 1;
    $rows = ! empty( $instance['rows'] ) ? $instance['rows'] : 1;
    $minprice = ! empty( $instance['minprice'] ) ? $instance['minprice'] : '';
    $maxprice = ! empty( $instance['maxprice'] ) ? $instance['maxprice'] : '';
    $sort  = ! empty( $instance['sort'] ) ? $instance['sort'] : '';
    $customid = ! empty( $instance['customid'] ) ? $instance['customid'] : '';
    $picwidth = ! empty( $instance['picwidth'] ) ? $instance['picwidth'] : '';
    $slideshow = ! empty( $instance['slideshow'] ) ? $instance['slideshow'] : 'None';    
    $slides = ! empty( $instance['slides'] ) ? $instance['slides'] : 3;
    ?>
  		<p>
  		<label for="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"><?php _e( esc_attr( 'Title:' ) ); ?></label> 
  		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'title' ) ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>">
  		</p>
  		<p>
  		<label for="<?php echo esc_attr( $this->get_field_id( 'content' ) ); ?>"><?php _e( esc_attr( 'Sub Title Link Text:' ) ); ?></label> 
  		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'content' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'content' ) ); ?>" type="text" value="<?php echo esc_attr( $content ); ?>">
  		</p>
  		<p>
  		<label for="<?php echo esc_attr( $this->get_field_id( 'query' ) ); ?>"><?php _e( esc_attr( $this->queryLabel ) ); ?></label> 
  		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'query' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'query' ) ); ?>" type="text" value="<?php echo esc_attr($query); ?>">
  		</p>
  		<p>
  		<label for="<?php echo esc_attr( $this->get_field_id( 'category' ) ); ?>"><?php _e( esc_attr( 'Categories (comma separated):' ) ); ?></label> 
  		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'category' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'category' ) ); ?>" type="text" value="<?php echo esc_attr($category); ?>">
  		</p>
      <p>
      <label><em><?php _e( esc_attr( '- Note: Search query or categories must be entered.' ) ); ?></em></label>
  		<p>
  		<label for="<?php echo esc_attr( $this->get_field_id( 'seller' ) ); ?>"><?php _e( esc_attr( 'Seller:' ) ); ?></label> 
  		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'seller' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'seller' ) ); ?>" type="text" value="<?php echo esc_attr($seller); ?>">
  		</p>
  		<p>
  		<label for="<?php echo esc_attr( $this->get_field_id( 'columns' ) ); ?>"><?php _e( esc_attr( 'Columns / Rows:' ) ); ?></label><br/> 
      <div style="display: flex; flex-direction: row;">
  		<input style="width: 40%; margin-right: 5px;" id="<?php echo esc_attr( $this->get_field_id( 'columns' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'columns' ) ); ?>" type="text" value="<?php echo esc_attr($columns); ?>">
  		<input style="width: 40%; margin-right: 5px;" id="<?php echo esc_attr( $this->get_field_id( 'rows' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'rows' ) ); ?>" type="text" value="<?php echo esc_attr($rows); ?>">
      </div>
  		</p>
  		<p>  		
  		<label for="<?php echo esc_attr( $this->get_field_id( 'minprice' ) ); ?>"><?php _e( esc_attr( 'Min / Max Price:' ) ); ?></label><br/> 
      <div style="display: flex; flex-direction: row;">
  		<input style="width: 40%; margin-right: 5px;" id="<?php echo esc_attr( $this->get_field_id( 'minprice' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'minprice' ) ); ?>" type="text" value="<?php echo esc_attr($minprice); ?>">
  		<input style="width: 40%; margin-right: 5px;" id="<?php echo esc_attr( $this->get_field_id( 'maxprice' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'maxprice' ) ); ?>" type="text" value="<?php echo esc_attr($maxprice); ?>">
      </div>
  		</p>
  		<p>
  		<label for="<?php echo esc_attr( $this->get_field_id( 'sort' ) ); ?>"><?php _e( esc_attr( 'Sort Order:' ) ); ?></label> 
      <select class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'sort' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'sort' ) ); ?>" >
      <?php foreach ($ebay_sort_order as $value => $desc) printf('<option value="%1$s" %2$s>%3$s</option>', $value, $sort == $value ? 'selected' : '', $desc); ?>    
      </select>
  		</p>
  		<p>
  		<label for="<?php echo esc_attr( $this->get_field_id( 'customid' ) ); ?>"><?php _e( esc_attr( 'Custom Tracking id:' ) ); ?></label> 
  		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'customid' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'customid' ) ); ?>" type="text" value="<?php echo esc_attr($customid); ?>">
  		</p>
  		<p>
  		<label for="<?php echo esc_attr( $this->get_field_id( 'picwidth' ) ); ?>"><?php _e( esc_attr( 'Picture Width:' ) ); ?></label> 
  		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'picwidth' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'picwidth' ) ); ?>" type="text" value="<?php echo esc_attr($picwidth); ?>">
  		</p>
  		<p>
  		<label for="<?php echo esc_attr( $this->get_field_id( 'slideshow' ) ); ?>"><?php _e( esc_attr( 'Slideshow: Style / Slides:' ) ); ?></label><br/>
      <div style="display: flex; flex-direction: row;">
      <select style="width: 40%; margin-right: 5px;"  id="<?php echo esc_attr( $this->get_field_id( 'slideshow' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'slideshow' ) ); ?>" >
      <?php foreach ($fu_ebay_slideshow_styles as $value) printf('<option value="%1$s" %2$s>%3$s</option>', $value, $slideshow == $value ? 'selected' : '', $value); ?>    
      </select>
  		<input style="width: 40%; margin-right: 5px;" id="<?php echo esc_attr( $this->get_field_id( 'slides' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'slides' ) ); ?>" type="text" value="<?php echo esc_attr($slides); ?>">
      </div>
      </p>
      <?php 
	}

	// widget update
	function update($new_instance, $old_instance) 
	{
    $instance = $old_instance;
    // Fields
    $instance['title'] = strip_tags($new_instance['title']);
    $instance['content'] = strip_tags($new_instance['content']);
    $instance['query'] = strip_tags($new_instance['query']);
    $instance['category'] = strip_tags($new_instance['category']);
    $instance['seller'] = strip_tags($new_instance['seller']);
    $instance['columns'] = intval($new_instance['columns']);
    $instance['rows'] = intval($new_instance['rows']);
    $instance['minprice'] = intval($new_instance['minprice']);
    $instance['maxprice'] = intval($new_instance['maxprice']);
    $instance['sort'] = strip_tags($new_instance['sort']);    
    $instance['customid'] = strip_tags($new_instance['customid']);
    $instance['picwidth'] = strip_tags($new_instance['picwidth']);
    $instance['slideshow'] = strip_tags($new_instance['slideshow']);
    $instance['slides'] = intval($new_instance['slides']);
    return $instance;
	}

	// widget display
	function widget($args, $instance) 
	{
    extract( $args );
    // these are the widget options
    $title = apply_filters('widget_title', $instance['title']);
    $content = ! empty( $instance['content'] ) ? $instance['content'] : '';
    $query = ! empty( $instance['query'] ) ? $instance['query'] : '';
    $category = ! empty( $instance['category'] ) ? $instance['category'] : '';
    $seller = ! empty( $instance['seller'] ) ? $instance['seller'] : '';
    $columns = ! empty( $instance['columns'] ) ? $instance['columns'] : 1;
    $rows = ! empty( $instance['rows'] ) ? $instance['rows'] : 1;
    $minprice = ! empty( $instance['minprice'] ) ? $instance['minprice'] : '';
    $maxprice = ! empty( $instance['maxprice'] ) ? $instance['maxprice'] : '';
    $sort  = ! empty( $instance['sort'] ) ? $instance['sort'] : '';
    $customid = ! empty( $instance['customid'] ) ? $instance['customid'] : '';
    $picwidth = ! empty( $instance['picwidth'] ) ? $instance['picwidth'] : -1;
    $slideshow = ! empty( $instance['slideshow'] ) ? $instance['slideshow'] : 'None';
    $slides = ! empty( $instance['slides'] ) ? $instance['slides'] : 3;
    
    echo $before_widget;
    // Display the widget
    ob_start();    

    // Check if title is set
    if ( $title ) {
      echo $before_title . $title . $after_title;
    }
    
    $apicall = new fuEbayBrowseSearchApiCall($content);
    $apicall->picWidth = $picwidth;
    $apicall->setQuery($query);
    $apicall->customId = $customid;
    $apicall->setCategories($category);
    $apicall->setSellers($seller);
    $apicall->setTableSize($columns, $rows);
    $apicall->setSlideShow($slideshow, $slides);
    $apicall->minPrice = $minprice;
    $apicall->maxPrice = $maxprice;
    $apicall->setSortOrder($sort);
    $apicall->arrangement = get_option('fubaby_ebayDefArrangementWidget', 0);    
    echo $apicall->call();    
 
    echo $after_widget;
    echo ob_get_clean();    
    
	}
}

// register widget
function fuEbayWidgetSearchRegisterFunc() { return register_widget("fuEbayWidgetSearch"); }
add_action('widgets_init', 'fuEbayWidgetSearchRegisterFunc');
 
 ////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dynamic ebay search widget
// Attempts to search eBay for items relating to current wordpress page displayed.
// Will use post title, term title or blog title.
class fuEbayWidgetSearchDynamic extends fuEbayWidgetSearch 
{
	// constructor
	function __construct($name = '') 
	{
    if (empty($name)) $name = __('Fast eBay Listings Dynamic Search', 'fastebaylistings');
    parent::__construct($name);
    $this->queryLabel = 'Default search query:';
	}
  
	// widget display
	function widget($args, $instance) 
	{
    $query = "";
    if (is_singular()) 
    {
      $query = get_post_meta(get_the_ID(), FUBABY_EBAY_META_KEY_PREFIX . "query", true);
      if (empty($query))
        $query = get_the_title();

      $metaValue = get_post_meta(get_the_ID(), FUBABY_EBAY_META_KEY_PREFIX . "category", true);
      if (!empty($metaValue))
        $instance['category'] = $metaValue;
      $metaValue = get_post_meta(get_the_ID(), FUBABY_EBAY_META_KEY_PREFIX . "seller", true);
      if (!empty($metaValue))
        $instance['seller'] = $metaValue;
      $metaValue = get_post_meta(get_the_ID(), FUBABY_EBAY_META_KEY_PREFIX . "minprice", true);
      if (!empty($metaValue))
        $instance['minprice'] = $metaValue;
      $metaValue = get_post_meta(get_the_ID(), FUBABY_EBAY_META_KEY_PREFIX . "maxprice", true);
      if (!empty($metaValue))
        $instance['maxprice'] = $metaValue;
    }
    if (empty($query))
      $query = single_term_title('', false);
    if (empty($query))
      $query = ! empty( $instance['query'] ) ? $instance['query'] : get_bloginfo('name');
     
    extract( $args );
    // these are the widget options
    $title = apply_filters('widget_title', $instance['title']);
    $content = ! empty( $instance['content'] ) ? $instance['content'] : $query;
    $category = ! empty( $instance['category'] ) ? $instance['category'] : '';
    $seller = ! empty( $instance['seller'] ) ? $instance['seller'] : '';
    $columns = ! empty( $instance['columns'] ) ? $instance['columns'] : 1;
    $rows = ! empty( $instance['rows'] ) ? $instance['rows'] : 1;
    $minprice = ! empty( $instance['minprice'] ) ? $instance['minprice'] : '';
    $maxprice = ! empty( $instance['maxprice'] ) ? $instance['maxprice'] : '';
    $customid = ! empty( $instance['customid'] ) ? $instance['customid'] : '';
    $picwidth = ! empty( $instance['picwidth'] ) ? $instance['picwidth'] : -1;
    $slideshow = ! empty( $instance['slideshow'] ) ? $instance['slideshow'] : 'None';
    $slides = ! empty( $instance['slides'] ) ? $instance['slides'] : 3;
    
    echo $before_widget;
    // Display the widget
    ob_start();    

    // Check if title is set
    if ( $title )
      echo $before_title . $title . $after_title;
        
    $apicall = new fuEbayBrowseSearchApiCall($content);
    $apicall->forceDeferredLoading(); // force deferred loading to avoid spiders hitting API on every page.
    $apicall->picWidth = $picwidth;
    $apicall->setQuery($query);
    $apicall->customId = $customid;
    $apicall->setCategories($category);
    $apicall->setSellers($seller);
    $apicall->setTableSize($columns, $rows);
    $apicall->setSlideShow($slideshow, $slides);
    $apicall->minPrice = $minprice;
    $apicall->maxPrice = $maxprice;
    $apicall->arrangement = get_option('fubaby_ebayDefArrangementWidget', 0);    
    
    $results = "";
    $results = $apicall->call();
    echo $results;
    
    echo $after_widget;
    echo ob_get_clean();    
    
	}
}
 
// register widget
function fuEbayWidgetSearchDynamicRegisterFunc() { return register_widget("fuEbayWidgetSearchDynamic"); }
add_action('widgets_init', 'fuEbayWidgetSearchDynamicRegisterFunc');
 